var hackerNews = (function( $, undefined ) {
                  var pub = {},
                  $this = $( this );
                  
                  pub.init = function() {
                  //Refresh news when btnRefresh is clicked
                  $( "#btnRefresh" ).live( "click", function() {
                                          pub.getAndDisplayNews();
                                          });
                  
                  //When news updated, display items in list
                  $this.bind( "news.updated", function( e, news ) {
                             displayNews( news );
                             });
                  
                  //When news updated, then set item count
                  $this.bind( "news.updated", function( e, news ) {
                             $( "#itemCount" ).text( news.items.length );
                             });
                  };
                  
                  pub.getAndDisplayNews = function() {
                  //Starting loading animation
                  $.mobile.pageLoading();
                  
                  //Get news and add success callback using then
                  getNews( function() {
                          //Stop loading animation on success
                          $.mobile.pageLoading( true );
                          });
                  };
                  
                  function getNews( callback ) {
                  //Get news via ajax and return jqXhr
                  $.ajax({
                         url: "http://api.ihackernews.com/page?format=jsonp",
                         dataType: "jsonp",
                         success: function( data, textStatus, xhr ) {
                         //Publish that news has been updated & allow
                         //the 2 subscribers to update the UI content
                         $this.trigger( "news.updated", data );
                         if ( callback ) callback( data );
                         }
                         });
                  }
                  
                  function displayNews( news ) {
                  var newsList = $( "#hackerNews" ).find( ".newsList" );
                  
                  //Empty current list
                  newsList.empty();
                  
                  //Use template to create items & add to list
                  $( "#newsItem" ).tmpl( news.items ).appendTo( newsList );
                  
                  //Call the listview jQuery UI Widget after adding 
                  //items to the list allowing correct rendering
                  newsList.listview( "refresh" );        
                  }
                  
                  return pub;
                  }( jQuery ));

hackerNews.init();
hackerNews.getAndDisplayNews();